package edu.ycp.cs201.exam2;

import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

public class Q9 {
	public static<E> boolean isAscending(List<E> list, Comparator<E> comp) {
		Iterator<E> i = list.iterator();
		E prev = i.next();
		
		while (i.hasNext()) {
			E cur = i.next();
			if (comp.compare(prev, cur) >= 0) {
				// previous element is greater than or equal to current
				// element, so the sequence is not an ascending sequence
				return false;
			}
			prev = cur;
		}
		
		return true;
	}
	
	static class ReverseComparator<E> implements Comparator<E> {
		private Comparator<E> delegate;
		
		public ReverseComparator(Comparator<E> delegate) {
			this.delegate = delegate;
		}
		
		@Override
		public int compare(E left, E right) {
			// Reverse the sense of the comparison done by the delegate
			return delegate.compare(right, left);
		}
	}

	// This method is for the bonus question
	public static<E> boolean isDescending(List<E> list, Comparator<E> comp) {
		return isAscending(list, new ReverseComparator<E>(comp));
	}
}
